<?php

set_time_limit(1800);
ini_set('memory_limit', '384M');

include("sendWhoAmI.php");
include("deldir.inc.php");
$logname="ft-data-zip.log";
$pid=getmypid();

// Wenn $logname existiert und älter als30 min ist löschen und weiter
// Wenn $logname existiert und jünger als30 min ist Abbruch
if (is_file($logname)){
    $time                 = 1800; // Sekunden
    $last_change          = filemtime($logname);
    $curent_timestamp     = time();
    $diffrence            = $curent_timestamp - $last_change;
    if($diffrence >= $time){
        unlink($logname);
        if (is_file("ftdata.zip")){
            unlink("ftdata.zip");
        }
    }else{
        exit;
    }
}


$log_handle=fopen($logname,'w');

fwrite($log_handle,'<tr><td>Refreshing remote data</td><td style="text-align:right;">(Step 1 of 7)</td></tr>');

$si = fopen('http://www.freietonne.de/ft_pois/freietonne-aktuell-gesamt-kacheln.php', 'r');
fclose($si);

fwrite($log_handle,"<tr><td>Downloading file ftdata.zip</td><td style=\"text-align:right;\">(Step 2 of 7)</td></tr>");

$contents='';
$fp = fopen('http://www.freietonne.de/seekarte/ft-data-zip.php?='.time(), 'r');
while (($fp)&&(!feof($fp))) {
    $contents .= fread($fp, 1024);
}
fclose($fp);

fwrite($log_handle,"<tr><td>Writing local ftdata.zip</td><td style=\"text-align:right;\">(Step 3 of 7)</td></tr>");

$newfile = fopen("ftdata.zip","w");

fwrite($newfile, $contents);
fclose($newfile);


fwrite($log_handle,"<tr><td>Exploding local ftdata.zip</td><td style=\"text-align:right;\">(Step 4 of 7)</td></tr>");

if (is_dir('tmp')){
   deldir('./tmp');
}

if (!is_dir('tmp')){
   mkdir('tmp');
}
// Heruntergeladene Datei auspacken
$zip = new ZipArchive;
$res = $zip->open("ftdata.zip");
if ($res === TRUE) {
  $zip->extractTo('tmp/');
  $zip->close();
}

fwrite($log_handle,'<tr><td>Rotating old and new folders </td><td style="text-align:right;">(Step 5 of 7)</td></tr>');
sleep(3); //wichtig!

rename("icons", "tmp/icons.old"); sleep(1);
rename("icons-yd", "tmp/icons-yd.old"); sleep(1);
rename("iconnamen", "tmp/iconnamen.old"); sleep(1);
rename("iconnamen-yd", "tmp/iconnamen-yd.old"); sleep(1);
rename("kacheln", "tmp/kacheln.old"); sleep(1);

sleep(3);


rename("tmp/icons", "icons"); sleep(1);
rename("tmp/icons-yd", "icons-yd"); sleep(1);
rename("tmp/iconnamen", "iconnamen"); sleep(1);
rename("tmp/iconnamen-yd", "iconnamen-yd"); sleep(1);
rename("tmp/kacheln", "kacheln"); sleep(1);


fwrite($log_handle,'<tr><td>Removing old local folders</td><td style="text-align:right;">(Step 6 of 7)</td></tr>');

sleep(3);

// alte Verzeichnisse löschen
deldir('./tmp');

fwrite($log_handle,'<tr><td>Cleaning local temp-files</td><td style="text-align:right;">(Step 7 of 7)</td></tr>');
fclose($log_handle);

while (is_file("ftdata.zip")){
    sleep(1);
    unlink("ftdata.zip");
}
while (is_file($logname)){
    sleep(1);
    unlink($logname);
}

echo "Text, damit http-Aufruf beendet wird. Nicht loeschen!!!";
?>

