#!/usr/bin/perl

if (-f "/bin/bash") {
  $clearcmd="clear";
}else{
  $clearcmd="cls";
}
system($clearcmd);

print "\n\n=============================================================================\n\n";
print "Hole ft_osm_icons.csv von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("wget -N http://www.freietonne.de/seekarte/ft_osm_icons.csv");

system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole ft_osm_kategorien.csv von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("wget -N http://www.freietonne.de/seekarte/ft_osm_kategorien.csv");


system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole openGeoDB.csv von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("wget -N http://www.freietonne.de/seekarte/openGeoDB.csv");

if (not(-d "kacheln")){
	mkdir "kacheln";
}
chdir "./kacheln";

system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole CSV-Kacheln von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("wget -q -N http://www.freietonne.de/ft_pois/freietonne-aktuell-gesamt-kacheln.php -O NUL");
system("rsync --delete --progress -W -rcv www.freietonne.de::freietonne-ft_kacheln/ ./");
chdir "./..";


if (not(-d "icons")){
	mkdir "icons";
}

chdir "./icons";
system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole ICONS von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("rsync --delete --progress -W -rtuv www.freietonne.de::freietonne-icons/ ./");

chdir "./..";

if (not(-d "png-km")){
	mkdir "png-km";
}

chdir "./png-km";
system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole png-km von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("rsync --delete --progress -W -rtuv www.freietonne.de::freietonne-png-km/ ./");

chdir "./..";

if (not(-d "png-tiefe")){
        mkdir "png-tiefe";
}

chdir "./png-tiefe";
system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole png-tiefe von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("rsync --delete --progress -W -rtuv www.freietonne.de::freietonne-png-tiefe/ ./");

chdir "./..";

if (not(-d "png-oben")){
        mkdir "png-oben";
}

chdir "./png-oben";
system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole png-oben von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("rsync --delete --progress -W -rtuv www.freietonne.de::freietonne-png-oben/ ./");


chdir "./..";
if (not(-d "iconnamen")){
        mkdir "iconnamen";
}

chdir "iconnamen";
system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole ICON-NAMEN von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("rsync --delete --progress -W -rtuv www.freietonne.de::freietonne-iconnamen/ ./");

chdir "./..";
if (not(-d "iconnamen-yd")){
        mkdir "iconnamen-yd";
}

chdir "iconnamen-yd";
system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole ICON-NAMEN (gelb) von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("rsync --delete --progress -W -rtuv www.freietonne.de::freietonne-iconnamen-yd/ ./");

chdir "./..";
if (not(-d "icons-yd")){
        mkdir "icons-yd";
}

chdir "icons-yd";
system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole Icons (gelb) von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("rsync --delete --progress -W -rtuv www.freietonne.de::freietonne-icons-yd/ ./");

chdir "./.." ;

if (not(-d "fluesse")){
        mkdir "fluesse";
}

chdir "fluesse";
system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole Waterways.gpx von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("wget -N http://www.freietonne.de/seekarte/fluesse/Waterways.gpx");

system($clearcmd);
print "\n\n=============================================================================\n\n";
print "Hole Canoe.gpx von www.freietonne.de\n\n\n";
print "\n\n=============================================================================\n\n";
system("wget -N http://www.freietonne.de/seekarte/fluesse/Canoe.gpx");

if ( -f "/etc/rsync-logbuch" ) {
	system("/bin/sh /etc/rsync-logbuch");
}



if ( -f "/bin/chown" ){
	chdir "./.." ;
	chdir "./.." ;
	if (not(-d "install")){
        	mkdir "install";
		if ( -f ft-install-linux-mod_tile.tgz ) {
			system("rm ft-install-linux-mod_tile.tgz");
		}
	}
        chdir "install";

	system("wget -N http://www.freietonne.de/downloads/ft-install-linux-mod_tile.tgz");
	system("cd /; tar --keep-newer-files -xzf /var/www/install/ft-install-linux-mod_tile.tgz >> /dev/null 2>&1");

	system("chown -R www-data.www-data /var/www/*");
}


exit;
