#!/usr/bin/perl


# Test ob lokal neue Pois
$file2="ft-selfpois-offline.gpx";
open (FTSELFP , "$file2") || die "Konnte $file2 nicht lesen: $!\n";
foreach $zeile (<FTSELFP>) {

  $testzeile=$zeile;
  $testzeile=~ s/ftanzeigenhoehe//igs;
  if ("$testzeile" ne "$zeile"){
    $neu="1";
    print "\nNeue Daten lokal gefunden. Abgleich.\n\n";
  }
}
close(FTSELF);
if ("$neu" ne "1") {
  exit;
}

# Zuerst holen wir die Komplettdatei vom Server
system("wget -N http://www.freietonne.de/ft_pois/freietonne-aktuell-gesamt-csv.php -O ft_osm_pois.zip");
system("unzip -o ft_osm_pois.zip");
unlink("ft_osm_pois.zip");

# Zuerst ffnen wir die Vergleichdaten und lesen sie einmalig ein

$file="ft_osm_pois.csv";

open(FTPOIS, $file) || die "Konnte $file nicht lesen: $!\n";
#undef $/;
foreach $zeile (<FTPOIS>){
	push(@ftpois,$zeile);
}
close(FTPOIS);
#print "@ftpois";

# Nun lesen wir die lokalen Pois ein, diese werden dann sequentiell
# mit den Vergleichsdaten abgeglichen. POIS, die schon in den Vergleichsdaten
# stehen, werden gelscht.

$file2="ft-selfpois-offline.gpx";
$tmp="ft-selfpois-offline.gpx.tmp";

$schreiben="ein";

open (TMP , ">$tmp") || die "Konnte $file2 nicht lesen: $!\n";
open (FTSELFP , "$file2") || die "Konnte $file2 nicht lesen: $!\n";
foreach $zeile (<FTSELFP>) {
	chomp $zeile;


	#print "Test $zeile\n";


	# Beginnt ein neuer Wegpunkt?
	$testzeile=$zeile;
	$testzeile=~ s/<wpt lat=//igs;
	if ("$testzeile" ne "$zeile") {

		# Wir Extrahieren die koordinaten
		#print "Anfangszeile wpt wird getestet ->  ";
		chomp $testzeile;
		$testzeile=~ s/ //igs;
		$testzeile=~ s/<wptlat=\"//igs;
		$testzeile=~ s/\"lon=\"/,/igs;
		$testzeile=~ s/\"//igs;
		$testzeile=~ s/>//igs;
		($lat,$lon)=split(/\,/,$testzeile);		

		#print "$lon	$lat\n\n";
		$testzeile="$lon	$lat";
		#$testzeile="13.763792859	52.43092613300001";
		
		# Jetzt schauen wir, ob wir einen solchen Datensatz schon haben
		foreach $xzeile (@ftpois) {
			$yzeile=$xzeile;
			$yzeile=~ s/$testzeile//igs;
			if (("$yzeile" ne "$xzeile") and ("$schreiben" eq "ein")){
				#print "Treffer, schreibe diesen Satz nicht\n";
				$schreiben="aus";
			}
		}
	}
	if ("$schreiben" eq "ein") {
		$zleer=$zeile;
		$zleer=~ s/ //igs;
		if (length($zleer) > 2) {
			print TMP "$zeile \n";
		}
	}

	# Endet Wegpunkt?
	$testzeile=$zeile;
	$testzeile=~ s/<\/wpt>//igs;
	if ("$testzeile" ne "$zeile") {
		if ("$schreiben" eq "ein"){
			print TMP "\n";
		}else{
			$schreiben="ein";
			#print "\nSchreiben eingeschaltet\n\n";
		}
	}


}
close(FTSELFP);
close(TMP);

system("mv -f \"ft-selfpois-offline.gpx.tmp\" \"ft-selfpois-offline.gpx\"");
system("chmod ugo+rwX \"ft-selfpois-offline.gpx\"");
