<?PHP

ini_set('memory_limit', '128M');

$kursverlauf = '';    // Kursverlauf aus

////////////////////////////////////////////////////////////////
// Fuer Android - Bildersuche abschalten
//
//
if (!is_file(".nomedia")){
  $datei = fopen(".nomedia","w");
  fwrite($datei, ".nomedia verhindert die Indizierung der *.png-Dateien unter Android!!!");
  fclose($datei);
}

if((isset($_GET['REPAIR']))||(isset($_GET['repair']))){
  setcookie("zoom","",time()-50);
  setcookie("lat","",time()-50);
  setcookie("lon","",time()-50);
  setcookie("gridStatus","",time()-50);
  setcookie("baselayer");
  setcookie("kursverlauf");
  setcookie("mailto");
  setcookie("km_stand");
  setcookie("km_oldlon");
  setcookie("km_oldlat");
  
  if (is_file("../freietonne-setup.php")){
    header("Location: ../freietonne-setup.php");
  }else{
    header("Location: ./"); 
  }
}

////////////////////////////////////////////////////////////////
//
// Sind wir online oder offline?
// (ACHTUNG EDITMODUS ist nicht EDITMODE!!!)
//
$ip = "www.freietonne.de"; // Change to your server's IP external or domain name
$port = "80"; // Make sure this port is open on the router or firewall

$output = @fsockopen("$ip", $port, $errno, $errstr, 3);
//stream_set_blocking($output,0);
//stream_set_timeout($output, 1);

if ((!$output)||($_SERVER['LOCAL_ADDR']="10.10.60.10")) {
    $inetONLINE='false';
    
} else {
    $inetONLINE='true';
    //include("sendWhoAmI.php");
}
@fclose($output);
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
//
// Falls Offline, gibt es im lokalen Netz einen tileserver?
// 
//
$tileserverONLINE='false';
$tileserver_ips = array("192.168.56.101",
                        "ftdl.de",
                        "10.10.60.8",
                        "10.10.61.8"); // Change to tileserver's IP or domain name

foreach ($tileserver_ips as $ip) {

    $fp = curl_init($ip);
            
    curl_setopt($fp,CURLOPT_TIMEOUT,3);
    curl_setopt($fp,CURLOPT_FAILONERROR,1);
    curl_setopt($fp,CURLOPT_RETURNTRANSFER,1);
    curl_exec($fp);
    if (curl_errno($fp) == 0){ 
          file_put_contents("tileserver_ip.conf",$ip);
          $tileserverONLINE='true';
          curl_close($fp);
          break;
    } 

    curl_close($fp);

}
////////////////////////////////////////////////////////////////



// Startwerte pro Gerät setzen

// Allgemein  (Wozu???)
$lat =  52.42;
if (strlen($_COOKIE["lat"])>0){$lat=$_COOKIE["lat"];}
if (isset($_GET['lat'])){ $lat = $_GET['lat']; }

$lon =  13.58009;
if (strlen($_COOKIE["lon"])>0){$lon=$_COOKIE["lon"];}
if(isset($_GET['lon']))  { $lon = $_GET['lon']; }

$zoom=13;
if (strlen($_COOKIE["zoom"])>0){$zoom=$_COOKIE["zoom"];}
if(isset($_GET['zoom'])) { $zoom = $_GET['zoom']; }

if (isset($_COOKIE["use_index2"])){
    setcookie("zoom",$zoom,time()+3600*24*30);
    setcookie("lat",$lat,time()+3600*24*30);
    setcookie("lon",$lon,time()+3600*24*30);

    if(isset($_GET['lat'])) {
        header('Location: index2.php?lat='.$lat.'&lon='.$lon);
        exit;
    }else{
        header('Location: index2.php');
        exit;
    }
}




$layers = 'Mapnik';  if(isset($_GET['layers'])) { $layers  = $_GET['layers']; }
$linuxoffline='';
$LINUXJAVASCRIPTSTART='';
$LINUXJAVASCRIPTEND='';
$maxzoom=17;
$EigeneProgramme='';

// ft-selfpois-offline.gpx bei Bedarf erstellen
if((!is_file("ft-selfpois-offline.gpx"))||(filesize("ft-selfpois-offline.gpx")<20)){
    file_put_contents("ft-selfpois-offline.gpx","<gpx>\r\n</gpx>\r\n");
}

// Inhaltsverzeichnis Eigene Programme erstellen
if (is_dir('../ft-privat')){
    $d = dir("../ft-privat");
    while (false !== ($entry = $d->read())) {
       if (($entry <> '.') && ($entry<>'..') && ($entry<>'geomail') &&($entry<>'BitMap')&& ($entry<>'.DS_Store') && ($entry<>'mapdownloads')){
         $entry_view=str_replace(".php", "", $entry);
         $entry_view=str_replace(".pl", "", $entry_view);
         $entry_view=str_replace(".html", "", $entry_view);
         $entry_view=str_replace(".htm", "", $entry_view);
         $entry_view=str_replace("_", " ", $entry_view);
    
    	   $EigeneProgramme=$EigeneProgramme.'<p><a target='.$entry.' onclick="document.getElementById(\'MenueDiv\').style.display = \'none\';" href=/ft-privat/'.$entry.'>'.$entry_view.'</a>';
       }
    }
    $d->close();
}

////////////////////////////////////////////////////////////////////////
// Prüfen ob Vorschauicon eingesetzt werden soll (bei ft-icon-layer)
//
//
$vorschauicon = 'false';
if(isset($_GET['vorschauicon'])) { $vorschauicon = 'true'; }



////////////////////////////////////////////////////////////////////////
// Welches Endgerät nutzen wir???
//
//
$offline = 'false';
$freietonne = 'false';
$macosx='false';
$windows='false';
$linuxplanet='false';
$iphone = 'false';
$ipad = 'false';
$android='false';
$is_josm='false';
$imeta = '';

// Falls Verzeichnis Tiles fehlt:
if (!is_dir('tah.openstreetmap.org')){
    mkdir('tah.openstreetmap.org');
}
if (!is_dir('tah.openstreetmap.org/Tiles')){
    mkdir('tah.openstreetmap.org/Tiles');
}
if (!is_dir('tah.openstreetmap.org/Tiles/tile')){
    mkdir('tah.openstreetmap.org/Tiles/tile');
}

//Wenn JOSM
if(@is_dir('/usr/josm')){
  $is_josm='true';
}

//Wenn Windows ft-USB
if(!is_file('../admin/_cfg.php')) {
   $windows='true';
   $offline = 'true';
   if(!isset($_GET['lat'])) { $kursverlauf = 'window.setTimeout("toogleKursverlauf()",5000);toogleKursverlauf();'; }
}
//Wenn FreieTonne-Server selbst
if(is_file('../admin/_cfg.php')) {
   $freietonne='true';
   //$ref = $_SERVER["HTTP_REFERER"];

   // Wir brauchen etwas Werbung ...
   //if( !preg_match('/freietonne.de/', $ref) ){
   //if ((strpos($_SERVER['HTTP_REFERER'],'freietonne.de') == FALSE)&&($_SERVER['HTTPS'] == FALSE)&&(!isset($_GET['lat']))){
   if ((strpos($_SERVER['HTTP_REFERER'],'freietonne.de') === FALSE)&&(!isset($_GET['lat']))&&(strpos($_SERVER['HTTP_USER_AGENT'],'Android') == FALSE)){
      header("Location: http://www.freietonne.de/");
      exit;
   }
}

//Wenn MacOSX Client ohne DB
if(is_dir('/Applications/XAMPP')) {
   $macosx='true';
   $offline = 'true';
   if(!isset($_GET['lat'])) { $kursverlauf = 'window.setTimeout("toogleKursverlauf()",5000);toogleKursverlauf();'; }
}

//Wenn Linux Client mit Planetfile, nicht Server
if(@is_file('/etc/mapnik-osm-data/osm.xml')||@is_file('/etc/mapnik-osm-carto-data/osm.xml')) {
   $linuxplanet='true';
   $linuxoffline='//';
   $LINUXJAVASCRIPTSTART='<!--';
   $LINUXJAVASCRIPTEND='-->';
   $maxzoom=18;
}

// Test Browsergeolocation unter Windows
//if(@is_file('/BrowserGeoLocation.LCK')){
//    $ipad = 'true';
//}

if((strpos($_SERVER['HTTP_USER_AGENT'],'AppleWebKit') !== FALSE AND
   strpos($_SERVER['HTTP_USER_AGENT'],'Mobile') !== FALSE) OR (
   strpos($_SERVER['HTTP_USER_AGENT'],'Android') !== FALSE)){

   // iPhone
   if(strpos($_SERVER['HTTP_USER_AGENT'],'iPhone') !== FALSE) {
      $iphone = 'true';
      $imeta = '
      <meta name="viewport" content="user-scalable=no, width=320">';
   }
   // iPad
   if(strpos($_SERVER['HTTP_USER_AGENT'],'iPad') !== FALSE) {
      $ipad = 'true';
      $imeta = '
      <meta name="viewport" content="user-scalable=no, width=device-width, initial-scale=1.0">';
      //$imeta='';
   }


   //"Mozilla/5.0 (Linux; U; Android 2.2; de-de; GT-P1000 Build/FROYO)
   // Android
   if(strpos($_SERVER['HTTP_USER_AGENT'],'Android') !== FALSE) {
      $android = 'true';
      $imeta = '
      <meta name="viewport" content="user-scalable=no, width=device-width, initial-scale=1.0">';
   }
}

if ($inetONLINE=='true'){
   $googleoffline='';
   $GOOGLEJAVASCRIPTSTART='';
   $GOOGLEJAVASCRIPTEND='';
   $maxzoom=18;
}else{
   // Google Werbung und GoogleMaps werden abgeschaltet
   $googleoffline='//';
   $GOOGLEJAVASCRIPTSTART='<!--';
   $GOOGLEJAVASCRIPTEND='-->';
   $maxzoom=18;
}


////////////////////////////////////////////////////////////////////////
// Eintragen im template html
//
//
$html = file_get_contents('template.html');
$html = str_replace('###LON###',$lon,$html);
$html = str_replace('###LAT###',$lat,$html);
$html = str_replace('###ZOOM###',$zoom,$html);
$html = str_replace('###LAYERS###',$layers,$html);
$html = str_replace('###OFFLINE###',$offline,$html);
$html = str_replace('###VORSCHAUICON###',$vorschauicon,$html);
$html = str_replace('###KURSVERLAUF###',$kursverlauf,$html);
$html = str_replace('###FREIETONNE###',$freietonne,$html);
$html = str_replace('###WINDOWS###',$windows,$html);
$html = str_replace('###MACOSX###',$macosx,$html);
$html = str_replace('###LINUXPLANET###',$linuxplanet,$html);
$html = str_replace('###IPHONE###',$iphone,$html);
$html = str_replace('###IPAD###',$ipad,$html);
$html = str_replace('###ANDROID###',$android,$html);
$html = str_replace('###JOSM###',$is_josm,$html);
$html = str_replace('###IMETA###',$imeta,$html);
$html = str_replace('###GOOGLEOFFLINE###',$googleoffline,$html);
$html = str_replace('###GOOGLEJAVASCRIPTSTART###',$GOOGLEJAVASCRIPTSTART,$html);
$html = str_replace('###GOOGLEJAVASCRIPTEND###',$GOOGLEJAVASCRIPTEND,$html);
$html = str_replace('###LINUXOFFLINE###',$linuxoffline,$html);
$html = str_replace('###LINUXJAVASCRIPTSTART###',$LINUXJAVASCRIPTSTART,$html);
$html = str_replace('###LINUXJAVASCRIPTEND###',$LINUXJAVASCRIPTEND,$html);
$html = str_replace('###MAXZOOM###',$maxzoom,$html);
$html = str_replace('###EIGENEPROGRAMME###',$EigeneProgramme,$html);
$html = str_replace('###ONLINESTATUS###',$inetONLINE,$html);
$html = str_replace('###TILESERVERONLINE###',$tileserverONLINE,$html);
$html = str_replace('###TILESERVERIP###',$ip,$html);

//header("Pragma: no-cache");
//header("Cache-Control: no-store, no-cache, max-age=0, must-revalidate");
//header('Content-Type: text/html; charset=utf-8');
echo $html; exit;


?>
