<?PHP

// -----------------------------------------------------------------------------
// Erfassung neue POOIS's in Google Earth
// -----------------------------------------------------------------------------
//

// -----------------------------------------------------------------------------
// Konfiguration
// -----------------------------------------------------------------------------
//
// Die Anzeigenhoehen sind hardcodiert!!
// Bei der FreieTonne existieren 3 Anzeigenhöhen für die Positionen
// 1 = Immer sichtbar
// 2 = Ab großer Höhe sichtbar
// 3 = Ab niedriger Höhe sichtbar
// -----------------------------------------------------------------------------

// GoogleEarth liefert: BBOX=-122.522859,37.721792,,-122.359974,37.813426
$bbox = explode(",",$_GET['BBOX']);
$ldez1 = $bbox[0];
$ldez2 = $bbox[2];
$bdez1 = $bbox[3];
$bdez2 = $bbox[1];

//if (abs($bdez1-$bdez2)> 0.17) {
if (abs($bdez1-$bdez2)> 0.015) {
      $KMLFILE='<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://earth.google.com/kml/2.2">
<Document xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<name>FreieTonne - GewÃ¤sserzeichen</name>
' ;
$KMLFILE .='
</Document>
</kml>';

header("Content-Type: text/plain; charset=utf-8");
echo 'lat'."\t".'lon'."\t".'title'."\t".'description'."\t".'iconSize'."\t".'iconOffset'."\t".'icon'."\r\n";
echo $bdez1-$bdez2;
echo $KMLFILE;
exit;
}

// Kartenausschnitt ist weit genug reingezoomt, machen wir weiter ...

$logofile = '/var/www/freietonne/logo.png';
if(is_file($logofile)) {
    $logofile="http://www.freietonne.de/logo.png" ;
}

   
// GoogleEarth liefert: BBOX=-122.522859,37.721792,,-122.359974,37.813426
$bbox = explode(",",$_GET['BBOX']);
$ldez1 = $bbox[0];
$ldez2 = $bbox[2];
$bdez1 = $bbox[3];
$bdez2 = $bbox[1];


$KMLFILE='<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://earth.google.com/kml/2.2">
<Document xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<name>FreieTonne - Datenerfassung</name>

<ScreenOverlay>
    <name>LOGO</name>
    <Icon>
      <href>' . $logofile . '</href>
    </Icon>
    <overlayXY x="0" y="1" xunits="pixels" yunits="pixels"/>
    <screenXY x="15" y="50" xunits="pixels" yunits="pixels"/>
    <rotationXY x="0" y="0" xunits="fraction" yunits="fraction"/>
    <size x="0" y="0" xunits="fraction" yunits="fraction"/>
</ScreenOverlay>
  
' ;


            $diffbreite=($bdez2-$bdez1)/2;
            $lat=$bdez1+$diffbreite;
            $difflaenge=($ldez1-$ldez2)/2;
            $lon=$ldez2+$difflaenge;
            $icon="http://www.freietonne.de/seekarte/winkelmesser/zoom6.png" ;
            $scale=1;
            $KMLFILE .='
      <Placemark>
      	 <name>Position neu:</name>
    <description><![CDATA[<center>Breite: ' . $lat . '<br />L&auml;nge: ' . $lon . '<br />
         <br />
         <a href="http://www.freietonne.de/index.php?site=38&infotyp=1&newgps=1&bdez=' . $lat . '&ldez=' . $lon . '">Neues Seezeichen</a><br />
         <br />(ACHTUNG: Das willkürliche Setzen von Markierungen kann großen Ärger im Projekt OpenStreetMap verursachen! Nur nutzen, wenn Du genau weißt, was Du tust!!!)<br />]]>
    </description>
      		
      		<Style>
      			<IconStyle>
      				<scale>'.$scale.'</scale>
      				<Icon>
      					<href>'.$icon.'</href>
      				</Icon>
      			</IconStyle>
      			<LabelStyle>
 
      				<scale>'.$labelscale.'</scale>
      			</LabelStyle>
      		</Style>
          <Point>
      			<coordinates>'.$lon.','.$lat.'</coordinates>
      	  </Point>

      </Placemark>

';


$KMLFILE .='
</Document>
</kml>';



header("Content-Type: text/plain; charset=utf-8");
//echo 'lat'."\t".'lon'."\t".'title'."\t".'description'."\t".'iconSize'."\t".'iconOffset'."\t".'icon'."\r\n";

echo $KMLFILE;
//echo "\r\n".$sql;
//echo "\r\n".$OP_CSV."\r\n";
?>

