<?PHP
// Um dieses Installationsprogramm auszuf&uuml;hren müssen folgende Voraussetzungen 
// erf&uuml;llt sein:
//    1.) Das Programm wird im root-Verzeichnis Ihres Webservers unter dem Namen
//        "freietonne-setup.php" gespeichert. Wichtig ist die Endung ".php"
//    2.) Im root-Verzeichnis des Webservers befindet sich noch kein Verzeichnis
//        "seekarte"
//    3.) Auf Ihrem Webserver ist PHP aktiviert
//
      
ini_set('memory_limit', '128M');
set_time_limit(21600);
ini_set('max_execution_time', '21600');

if ($_SERVER["SERVER_NAME"] == "www.freietonne.de"){

    header('Content-Type: application/csv');
    header('Content-Disposition: attachment; filename=freietonne-setup.php');
    header('Pragma: no-cache');
    readfile("freietonne-setup.php");
    exit;

}

$ft_root="seekarte";
$URLserverPRG="http://www.freietonne.de/seekarte/sync";
$SERVERconfig="www.php";
$rootdir="$ft_root";



if (!is_dir($ft_root)){
    mkdir($ft_root);  
}
if (!is_dir($ft_root."/sync")){
    mkdir($ft_root."/sync");  
}
if (!is_dir($ft_root."/sync/config")){
    mkdir($ft_root."/sync/config");  
}
if(!is_dir($ft_root."/sync/config")){
	die("<br /><br />Verzeichnis <b>\"$ft_root/sync/config\"</b> konnte nicht erstellt werden! Abbruch.");
	exit;
}
chdir($ft_root);
function download($URLserverPRG,$SERVERconfig,$file){

    // Datei downloaden
    $dateiinhalt = @file_get_contents($URLserverPRG."/sendfile.php?config=".$SERVERconfig."&filename=".$file);
    $fp = fopen($file, "w");
    fwrite($fp, $dateiinhalt);
    fclose($fp);
    @chmod($file,0666);
}





download($URLserverPRG,$SERVERconfig,"sync/client.php");
download($URLserverPRG,$SERVERconfig,"sync/client-monitor.php");
download($URLserverPRG,$SERVERconfig,"sync/dir.php");
download($URLserverPRG,$SERVERconfig,"sync/dirGZ.php");
download($URLserverPRG,$SERVERconfig,"sync/sendfile.php");
download($URLserverPRG,$SERVERconfig,"sync/sendfileGZ.php");
download($URLserverPRG,$SERVERconfig,"sync/verlauf2.gif");
//download($URLserverPRG,$SERVERconfig,"sync/config/android.php");
//download($URLserverPRG,$SERVERconfig,"sync/config/default.php");
//download($URLserverPRG,$SERVERconfig,"sync/config/ftdl.php");
//download($URLserverPRG,$SERVERconfig,"sync/config/linux.php");
//download($URLserverPRG,$SERVERconfig,"sync/config/MacOSX.php");
//download($URLserverPRG,$SERVERconfig,"sync/config/test.php");
//download($URLserverPRG,$SERVERconfig,"sync/config/windows.php");
download($URLserverPRG,$SERVERconfig,"sync/config/www.php");
download($URLserverPRG,$SERVERconfig,"sync/config/freietonne-setup.php");
if(is_file("../freietonne-setup.php")){
    copy("sync/config/freietonne-setup.php","../freietonne-setup.php");
}

?>

<html>
<head>
<script type="text/javascript"> 

function fensterHoehe(){
    var hall=0;
    if(window.innerHeight) {
        hall=document.getElementById("all").offsetHeight;
        if ((window.innerHeight/2-hall/2 > 0) && (hall)){
           document.getElementById("all").style.marginTop=window.innerHeight/2-hall/2;
        }else{
           document.getElementById("all").style.marginTop=2;
        }

    }
    document.getElementById("all").style.marginLeft="10%";
}

function init(){
    fensterHoehe();
}

</script>
</head>
<body onload="init();">

<div id="all" style="max-width:80%; marging:0px; padding:0px; border-width:2px; border-style: solid; border-color: grey;border-radius:5px;">

<table style="text-align:left;"><tr><td>
<img src="http://www.freietonne.de/favicon-ft-196-android.png">
</td><td>
<h2>Installation/ Update FreieTonne-Seekarte</h2>

<p>Zum Start des Installationsvorganges <a href="/seekarte/sync/client-monitor.php?"> hier klicken! </a></p>
<p>Abh&auml;ngig von der Geschwindigkeit Ihrer Internetverbindung und der augenblicklichen 
Auslastung unserer Server kann die Installation einige Stunden dauern. Die 
Installation kann jederzeit unterbrochen, und sp&auml;ter fortgesetzt werden.</p>
<p>Nach Abschlu&szlig; der Installation <a href=/seekarte>starten Sie unsere FreieTonne-Seekarte hier</a></p>
</td></tr></table></div>
</body>
</html>
