<?PHP
error_reporting(E_ALL ^ E_NOTICE);

//error_reporting(0);

set_time_limit(120);
ini_set('allow_url_fopen', '1');
ini_set('memory_limit', '512M');

$nordmem=$_GET['bdez1'];
$westmem=$_GET['ldez1'];
$suedmem=$_GET['bdez2'];
$ostmem=$_GET['ldez2'];

$aktzoom=$_GET['zoom'];
$pluszoom=4;


$tileserver='http://ftdl.de/tile-cache/tiles/';
$tileserver=trim(file_get_contents('tileserver_ip.conf'));
$localserver=str_replace("localhost","127.0.0.1",$_SERVER["HTTP_HOST"]);

echo "Antwort für xhttp-Aufruf $tileserver";

function tilesHolen($z,$x,$y,$logname,$localserver,$tileserver){
    
    $r="freietonne";

    $file = "./${z}/${x}/$y.png";
    $dir_tile = './';
    $dir_tile_r = './';
    $dir_tile_r_z = './'.$z;
    $dir_tile_r_z_x = './'.$z.'/'.$x;


 
     if (is_file($file)){
        if (strpos(file_get_contents($file),'<html>')||strpos(file_get_contents($file),'<b>Warning</b>:')||filesize($file) == 0){
          unlink($file); 
        }
      }
      
      if(!is_dir($dir_tile)){mkdir($dir_tile);};
      if(!is_dir($dir_tile_r)){mkdir($dir_tile_r);};
      if(!is_dir($dir_tile_r_z)){mkdir($dir_tile_r_z);};
      if(!is_dir($dir_tile_r_z_x)){mkdir($dir_tile_r_z_x);};      
      
      $server = array();
      switch ($r)
      {
      	case 'mapnik':
          $server[] = 'a.tile.openstreetmap.org';
          $server[] = 'b.tile.openstreetmap.org';
          $server[] = 'c.tile.openstreetmap.org';

          $url = 'http://'.$server[array_rand($server)];
          $url .= "/".$z."/".$x."/".$y.".png";
          break;

      	case 'osma':
      	default:
          $server[] = 'a.tah.openstreetmap.org';
          $server[] = 'b.tah.openstreetmap.org';
          $server[] = 'c.tah.openstreetmap.org';

          $url = 'http://'.$server[array_rand($server)].'/tile/tile.php';
          $url .= "/".$z."/".$x."/".$y.".png";
          break;

      	case 'freietonne':
      	default:
          $server[] = $tileserver;

          $url = 'http://'.$server[array_rand($server)].'/osm';
          $url .= "/".$z."/".$x."/".$y.".png";
          break;
      }



      $ch = curl_init($url);
      $fp = fopen($file, "w");
      curl_setopt($ch, CURLOPT_FILE, $fp);
      curl_setopt($ch, CURLOPT_HEADER, 0);
      curl_setopt($ch, CURLOPT_TIMEOUT,30);
      curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,60);
      curl_exec($ch);
      curl_close($ch);
      fflush($fp);    // need to insert this line for proper output when tile is first requestet
      fclose($fp);
      chmod($file, 0666);
      // Wir verlängern die Zeit für das Script dynamisch nach Bedarf
      set_time_limit(120);

      if (is_file($file)){
        if (strpos(file_get_contents($file),'<html>')||strpos(file_get_contents($file),'<b>Warning</b>:')||filesize($file) == 0){
          unlink($file);
          sleep(1); 
        }
      }

}





$dir="tah.openstreetmap.org/Tiles/tile";

chdir($dir);

if (!is_dir("tmp")){
  mkdir("tmp");
}

if (is_file('planet-import-complete')){
    unlink('planet-import-complete');
}
if (is_file('planet-import-complete.01')){
    unlink('planet-import-complete.01');
}
if (!is_file('planet-import-complete.02')){
    touch('planet-import-complete.02');
}
$planetAge=filemtime('planet-import-complete.02');

if (!is_file('0/0/0.png')){
    tilesHolen(0,0,0,$logname,$localserver,$tileserver);
}

$logname="tmp/wget_".$nordmem.'_'.$westmem.'_'.$suedmem.'_'.$ostmem.".php";
$logname2="tmp/wget_".$nordmem.'_'.$westmem.'_'.$suedmem.'_'.$ostmem.".2.php";

$logtext='<?PHP echo "http://'.$localserver.'/seekarte/tah.openstreetmap.org/Tiles/tile/0/0/0.png"; ?>';
$log_handle=fopen($logname,'w');
fwrite($log_handle,$logtext);
fflush($log_handle);
fclose($log_handle);

$logtext2='<?PHP echo "Errechne Anzahl Tiles ...";?>';
$log_handle2=fopen($logname2,'w');
fwrite($log_handle2,$logtext2);
fflush($log_handle2);
fclose($log_handle2);

//////////////////////////////////////////////////
// Zuerst zaehlen wir, wie viele Tiles geholt werden sollen

$anzahl_tiles=0;

$step=0.0005;
if ($aktzoom>17){
  $aktzoom=17;
}

$maxzoom=$aktzoom+$pluszoom;
if ($maxzoom>17){
  $maxzoom=17;
}
$zoom=1;

while ($zoom <= $maxzoom) {

    $step=0.0005;
    if ($zoom < 19){
        $step=0.0005;
    }
    if ($zoom < 18){
        $step=0.001;
    }
    if ($zoom < 17){
        $step=0.003;
    }
    if ($zoom < 16){
        $step=0.005;
    }
    if ($zoom < 15){
        $step=0.011;
    }
    if ($zoom < 14){
        $step=0.022;
    }
    if ($zoom < 13){
        $step=0.044;
    }
    if ($zoom < 12){
        $step=0.088;
    }
    if ($zoom < 11){
        $step=0.176;
    }
    if ($zoom < 10){
        $step=0.352;
    }
    if ($zoom < 9){
        $step=0.703;
    }
    if ($zoom < 8){
        $step=1.406;
    }
    if ($zoom < 7){
        $step=2.83;
    }
    if ($zoom < 6){
        $step=5.625;
    }
    if ($zoom < 5){
        $step=11.25;
    }
    if ($zoom < 4){
        $step=22.5;
    }
    if ($zoom < 3){
        $step=45;
    }
    if ($zoom < 1){
        $step=90;
    }



    // Wir verbreitern konisch nach oben, nicht nach unten
    $nord=$nordmem;
    $sued=$suedmem;
    $west=$westmem;
    $ost=$ostmem;
    if ($zoom < $aktzoom){
        $nord=$nordmem+$step;
        $sued=$suedmem-$step;
        $west=$westmem-$step;
        $ost=$ostmem+$step;
    }

  	$lon=($west*1);
  	$lat=($nord*1);
  
  	$oxtile=0;
  	$oytile=0;
  
  
  
  	while ($lat >= $sued) {
  		while ($lon <= $ost) {
  
        $xtile = floor((($lon + 180) / 360) * pow(2, $zoom));
        $ytile = floor((1 - log(tan(deg2rad($lat)) + 1 / cos(deg2rad($lat))) / pi()) /2 * pow(2, $zoom));
  
  			if ((($xtile <> $oxtile) or ($ytile <> $oytile)) and ($xtile>=0)and($ytile>=0)){
              $anzahl_tiles=$anzahl_tiles+1;
  
  			}
  			$oxtile=$xtile;
  			$oytile=$ytile;
  
  			$lon=$lon+$step;
  		}
  		$lon=$west;
  		$lat=$lat-$step;
  
  	}

    $zoom=$zoom+1;
}





//////////////////////////////////////////////////
// Jetzt werden die Bilder wirklich geholt

$nord=$_GET['bdez1'];
$west=$_GET['ldez1'];
$sued=$_GET['bdez2'];
$ost=$_GET['ldez2'];
$aktzoom=$_GET['zoom'];;




$anzahl_bisher=0;
$startzeit=time();

$step=0.0005;
if ($aktzoom>17){
  $aktzoom=17;
}

$maxzoom=$aktzoom+$pluszoom;
if ($maxzoom>17){
  $maxzoom=17;
}
$zoom=1;

while ($zoom <= $maxzoom) {

    $step=0.0005;
    if ($zoom < 19){
        $step=0.0005;
    }
    if ($zoom < 18){
        $step=0.001;
    }
    if ($zoom < 17){
        $step=0.003;
    }
    if ($zoom < 16){
        $step=0.005;
    }
    if ($zoom < 15){
        $step=0.011;
    }
    if ($zoom < 14){
        $step=0.022;
    }
    if ($zoom < 13){
        $step=0.044;
    }
    if ($zoom < 12){
        $step=0.088;
    }
    if ($zoom < 11){
        $step=0.176;
    }
    if ($zoom < 10){
        $step=0.352;
    }
    if ($zoom < 9){
        $step=0.703;
    }
    if ($zoom < 8){
        $step=1.406;
    }
    if ($zoom < 7){
        $step=2.83;
    }
    if ($zoom < 6){
        $step=5.625;
    }
    if ($zoom < 5){
        $step=11.25;
    }
    if ($zoom < 4){
        $step=22.5;
    }
    if ($zoom < 3){
        $step=45;
    }


    // Wir verbreitern konisch nach oben, nicht nach unten
    $nord=$nordmem;
    $sued=$suedmem;
    $west=$westmem;
    $ost=$ostmem;
    if (($zoom < $aktzoom)&&($zoom>3)){
        $nord=$nordmem+$step;
        $sued=$suedmem-$step;
        $west=$westmem-$step;
        $ost=$ostmem+$step;
    }

  	$lon=($west*1);
  	$lat=($nord*1);
  
  	$oxtile=0;
  	$oytile=0;
  
  	while ($lat >= $sued) {
  		while ($lon <= $ost) {
  
        $xtile = floor((($lon + 180) / 360) * pow(2, $zoom));
        $ytile = floor((1 - log(tan(deg2rad($lat)) + 1 / cos(deg2rad($lat))) / pi()) /2 * pow(2, $zoom));
  
  			if ((($xtile <> $oxtile) or ($ytile <> $oytile)) and ($xtile>=0)and($ytile>=0)){
          $anzahl_bisher=$anzahl_bisher+1; 
          
          if ((!is_nan($ytile))&&(!is_nan($xtile))){
              $file=$zoom.'/'.$xtile.'/'.$ytile.'.png';
              if ((!is_file($file))||strpos(file_get_contents($file),'<html>')||strpos(file_get_contents($file),'<b>Warning</b>:')||filesize($file) == 0 || filemtime($file) < $planetAge){      
                tilesHolen($zoom,$xtile,$ytile,$logname,$localserver,$tileserver); 
              
                // Schreiben wir den Bearbeitungsstand in eine Textdatei, die dann
                // durch wget_tiles_monitor.php ausgelesen wird
                if (is_file($file)){
                  $logtext='<?PHP echo "http://'.$localserver.'/seekarte/tah.openstreetmap.org/Tiles/tile/'.$zoom.'/'.$xtile.'/'.$ytile.'.png";?>';
                  $log_handle=fopen($logname,'w');
                  fwrite($log_handle,$logtext);
                  fflush($log_handle);
                  fclose($log_handle);                
                }  
  
          //}
          if (($xtile>=0)and($ytile>=0)){
              $fortschrittspixel=round($anzahl_bisher*256/$anzahl_tiles);
              $fortschrittsprozent=($anzahl_bisher*100/$anzahl_tiles); // nicht runden wegen später division durch 0
              $timestamp=time();
              $zeitschaetzungGesamt=round(($timestamp-$startzeit)*100/$fortschrittsprozent*100)/100;
              $eta=(round($zeitschaetzungGesamt*(100-$fortschrittsprozent))/100)/60;
              if ($eta >= 1){
                  $eta=round(($zeitschaetzungGesamt-($timestamp-$startzeit))/60);
                  $eta=round($eta).' min';
              }else{
                  $eta=round($zeitschaetzungGesamt-($timestamp-$startzeit)).' sec';
              }
              
              $logtext='<?PHP echo "http://'.$localserver.'/seekarte/tah.openstreetmap.org/Tiles/tile/0/0/0.png";?>';
              $logtext2='<?PHP echo "<p>'.$anzahl_bisher.' von '.$anzahl_tiles.' = '.round($fortschrittsprozent).'%';
              
              if (($fortschrittsprozent>5)or($eta>0)){
                  $logtext2=$logtext2.', '.$eta;
              }
              
              $logtext2=$logtext2.'</p>";';
  
              $logtext2=$logtext2.'echo "<center><div style=\"text-align:left;width:256px;height:18px;background-color:lightblue\";><div style=\"background-color:grey;height:18px;width:'.$fortschrittspixel.'px;\"></div></div></center>";' ;
              $logtext2=$logtext2.' echo "<p>Zoom: '.$zoom.' von '.$maxzoom.' ('.$xtile.'/'.$ytile.')</p>"; ?>';
  
  
  
              $log_handle2=fopen($logname2,'w');
              fwrite($log_handle2,$logtext2);
              fflush($log_handle2);
              fclose($log_handle2);
  
          }
          }
          }
  
  			}
  			$oxtile=$xtile;
  			$oytile=$ytile;
  
  			$lon=$lon+$step;
  
  
  
  		}
  		$lon=$west;
  		$lat=$lat-$step;
  
  	}
  
  	$zoom=$zoom+1;
}


if (is_file($logname)){unlink($logname);}
if (is_file($logname2)){unlink($logname2);}

?>
