// Script zum Fenstergre Verndern
// Wird als Funktion bentigt, da IE einen bereits gesetzten BODY bentigt
// wird entsprechend beim onLoad-Event aufgerufen.
// bergeben werden die Werte fr bentigte Innengre in Pixel [x INT, y INT] 

function winResize (xInnenSoll,yInnenSoll) {
	var xPos	= 100; // Abstand links vom Bildschirm - Fensteropsition
	var yPos	= 100; // Abstand oben  vom Bidlschirm - Fensterposition
	var xInnenIst   = 0;
	var yInnenIst   = 0;
	var xAussenIst  = 0;
	var yAussenIst  = 0;
	var xAussenSoll = 0;
	var yAussenSoll = 0;
	var xNotfall	= 8;   // Wenn Browser keine Daten liefert
	var yNotfall	= 113; // geschtzte manuelle Werte fr alle Browser
	var check = 'NoJS1.2'; // Fr DEBUG-Ausgabe, welcher Browser-Typ gewhlt wurde

	// Muss fr IE schon veschoben werden, da wenn Browserfenster teilweise
	// ausserhalb des sichtbaren Bildschirmsverschoben wird, es zu fehlerhaften 
	// Werten kommen kann.
	//window.moveTo(xPos,yPos);

	// Trick-Resize, um Werte zu berechnen
	// da Aussenwerte von IE nicht erfasst / ausgegeben werden.
	xAussenIst = 640;
	yAussenIst = 480;
	window.resizeTo(xAussenIst,yAussenIst);

	// Prfung ob normaler Browser (kein IE)
	if(window.innerWidth && window.outerWidth) {
		xInnenIst   = window.innerWidth;
		yInnenIst   = window.innerHeight;
		xAussenSoll = (xAussenIst - xInnenIst) + xInnenSoll;
		yAussenSoll = (yAussenIst - yInnenIst) + yInnenSoll;
		check = 'NoIE';
	
	// Prfung fr IE6+ im Standard-Konformen Modus
	} else if (document.documentElement.clientWidth) {
		xInnenIst = document.documentElement.clientWidth;
		yInnenIst = document.documentElement.clientHeight;
		xAussenSoll = (xAussenIst - xInnenIst) + xInnenSoll;
		yAussenSoll = (yAussenIst - yInnenIst) + yInnenSoll;
		check = 'IE6+ SKM';

	// Prfung fr IE6+ im NICHT Standard-Konformen Modus
	// und anderen IE Versionen
	} else if(document.body.clientWidth) {
		xInnenIst = document.body.clientWidth;
		yInnenIst = document.body.clientHeight;		
		xAussenSoll = (xAussenIst - xInnenIst) + xInnenSoll;
		yAussenSoll = (yAussenIst - yInnenIst) + yInnenSoll;
		check = 'IE';

	// Wenn Browser garnichts untersttzt, werden feste Werte gesetzt
	} else {
		xAussenSoll = xInnenSoll + xNotfall;
		yAussenSoll = yInnenSoll + yNotfall;
	}
	        	
	window.resizeTo(xAussenSoll,yAussenSoll)
	
	// Einige Browser oder Systeme setzen das Fenster nicht auf
	// die richtige Position, aber im Endeffekt ist es bei allen
	// im sichtabren Bereich oben links in der Ecke dann.
	// (Grund unbekannt :-)
	//window.moveTo(xPos,yPos);

	// DEBUG
	// Anzeige der berechneten Werte sowie gewhlter Browser-Typ
	// var Werte = '(' + xAussenSoll + 'x' + yAussenSoll + ')' + ' ' + check;
	// window.alert(Werte);
}

