<?PHP

// Einlesen der eigenen POIs
$gpx = file_get_contents('ft-selfpois-offline.gpx');
$xml = new SimpleXMLElement($gpx);

// Erstellen der Suchparameter
$ldez1 = $_GET['ldez1'];
$ldez2 = $_GET['ldez2'];
$bdez1 = $_GET['bdez1'];
$bdez2 = $_GET['bdez2'];
$zoom  = $_GET['zoom'];

$zoomcheck = array(1);
if($zoom > 12) {
   $zoomcheck[] = 2;
   $zoomcheck[] = 3;
} elseif($zoom >= 9) {
   $zoomcheck[] = 2;
}

$OP_CSV='';

// Erstellen von vorhandenen POIs
foreach($xml->wpt AS $pos) {

   // Wenn innerhalb des Anzeigenbereichs
   if($pos['lat'] > $bdez2 AND $pos['lat'] < $bdez1 AND
      $pos['lon'] > $ldez1 AND $pos['lon'] < $ldez2 AND
      in_array($pos->ftanzeigenhoehe,$zoomcheck)) {

      $textbild = 'iconnamenself/'.$pos->ftid.'.png';
      if(is_file($textbild)) {
         $tb = getimagesize($textbild);
         $size = $tb[0].','.$tb[1]."\t".'0,0';
         $icon = $textbild;
      } else {
         $size = '10,10'."\t".'-5,-5';
         if($zoom >= 15) { $size = '14,14'."\t".'-7,-7'; }
         if($pos->ftanzeigenhoehe == 1 OR $pos->ftanzeigenhoehe == 2) { $size = '16,16'."\t".'-8,-8'; }
         $icon = 'icons/'.$pos->sym.'.png';
      }
      
      // Koordinaten & Name
      $OP_CSV .= $pos['lat']."\t";
      $OP_CSV .= $pos['lon']."\t";
      $OP_CSV .= '<span style="font-size:12px;">'.$pos->name.'</span>'."\t";

      // Beschreibung - Popup
      $OP_CSV .= '<span style="font-size:12px;">';
      //$OP_CSV .= '<a href="#" style="text-decoration:none;" ';
      $OP_CSV .= '<a href="ft-editpois.php?delgps='.$pos->ftid.'" style="text-decoration:none;">';
      //$OP_CSV .= 'onclick="window.open(\'ft-editpois.php?delgps='.$pos->ftid.'\',\'FreieTonne\',\'width=640,height=480,menubar=no,scrollbars=yes\');">';
      //$OP_CSV .= 'onclick="ft-editpois.php?delgps='.$pos->ftid.'">';
      $OP_CSV .= 'Löschen</a> ('.$pos->ftid.')<br /><br />';
      $OP_CSV .= $pos->cmt.'</span>'."\t";

      // Größen & Icons
      $OP_CSV .= $size."\t";
      $OP_CSV .= $icon."\r\n";
   }
}



header("Content-Type: text/plain; charset=utf-8");
echo 'lat'."\t".'lon'."\t".'title'."\t".'description'."\t".'iconSize'."\t".'iconOffset'."\t".'icon'."\r\n";
echo $OP_CSV;
?>
