<?PHP

ini_set('memory_limit', '128M');

setcookie("use_index2", '1');

$kursverlauf = '';    // Kursverlauf aus

////////////////////////////////////////////////////////////////
// Fuer Android - Bildersuche abschalten
//
//
if (!is_file(".nomedia")){
  $datei = fopen(".nomedia","w");
  fwrite($datei, ".nomedia verhindert die Indizierung der *.png-Dateien unter Android!!!");
  fclose($datei);
}

if((isset($_GET['REPAIR']))||(isset($_GET['repair']))){
  setcookie("zoom","",time()-50);
  setcookie("lat","",time()-50);
  setcookie("lon","",time()-50);
  setcookie("gridStatus","",time()-50);
  setcookie("baselayer");
  setcookie("kursverlauf");
  setcookie("mailto");
  setcookie("km_stand");
  setcookie("km_oldlon");
  setcookie("km_oldlat");
  
  if (is_file("../freietonne-setup.php")){
    header("Location: ../freietonne-setup.php");
  }else{
    header("Location: ./"); 
  }
}

$tileserverONLINE='false';
$inetONLINE='false';
$ip="no tileserver";

// Startwerte pro Gerät setzen

// Allgemein  (Wozu???)
$lat =  52.42;
if (isset($_COOKIE["lat"])){$lat=$_COOKIE["lat"];}
if (isset($_GET['lat'])){ $lat = $_GET['lat']; }

$lon =  13.58009;
if (isset($_COOKIE["lon"])){$lon=$_COOKIE["lon"];}
if(isset($_GET['lon']))  { $lon = $_GET['lon']; }

$zoom=13;
if (isset($_COOKIE["zoom"])){$zoom=$_COOKIE["zoom"];}
if(isset($_GET['zoom'])) { $zoom = $_GET['zoom']; }

$layers = 'Mapnik';  if(isset($_GET['layers'])) { $layers  = $_GET['layers']; }
$linuxoffline='';
$LINUXJAVASCRIPTSTART='';
$LINUXJAVASCRIPTEND='';
$maxzoom=17;
$EigeneProgramme='';

// ft-selfpois-offline.gpx bei Bedarf erstellen
if((!is_file("ft-selfpois-offline.gpx"))||(filesize("ft-selfpois-offline.gpx")<20)){
    file_put_contents("ft-selfpois-offline.gpx","<gpx>\r\n</gpx>\r\n");
}

// Inhaltsverzeichnis Eigene Programme erstellen
if (is_dir('../ft-privat')){
    $d = dir("../ft-privat");
    while (false !== ($entry = $d->read())) {
       if (($entry <> '.') && ($entry<>'..') && ($entry<>'geomail') &&($entry<>'BitMap')&& ($entry<>'.DS_Store') && ($entry<>'mapdownloads')){
         $entry_view=str_replace(".php", "", $entry);
         $entry_view=str_replace(".pl", "", $entry_view);
         $entry_view=str_replace(".html", "", $entry_view);
         $entry_view=str_replace(".htm", "", $entry_view);
         $entry_view=str_replace("_", " ", $entry_view);
    
    	   $EigeneProgramme=$EigeneProgramme.'<p><a target='.$entry.' onclick="document.getElementById(\'MenueDiv\').style.display = \'none\';" href=/ft-privat/'.$entry.'>'.$entry_view.'</a>';
       }
    }
    $d->close();
}

////////////////////////////////////////////////////////////////////////
// Prüfen ob Vorschauicon eingesetzt werden soll (bei ft-icon-layer)
//
//
$vorschauicon = 'false';
if(isset($_GET['vorschauicon'])) { $vorschauicon = 'true'; }



////////////////////////////////////////////////////////////////////////
// Welches Endgerät nutzen wir???
//
//
$offline = 'false';
$freietonne = 'false';
$macosx='false';
$windows='false';
$linuxplanet='false';
$iphone = 'false';
$ipad = 'false';
$android='false';
$is_josm='false';
$imeta = '';

// Falls Verzeichnis Tiles fehlt:
if (!is_dir('tah.openstreetmap.org')){
    mkdir('tah.openstreetmap.org');
}
if (!is_dir('tah.openstreetmap.org/Tiles')){
    mkdir('tah.openstreetmap.org/Tiles');
}
if (!is_dir('tah.openstreetmap.org/Tiles/tile')){
    mkdir('tah.openstreetmap.org/Tiles/tile');
}

//Wenn JOSM
if(@is_dir('/usr/josm')){
  $is_josm='true';
}

//Wenn Windows ft-USB
//if(!is_file('../admin/_cfg.php')) {
if(is_dir("/xampp")){
   $windows='true';
   $offline = 'true';
   if(!isset($_GET['lat'])) { $kursverlauf = 'window.setTimeout("toogleKursverlauf()",5000);toogleKursverlauf();'; }
   $EigeneProgramme=$EigeneProgramme.'<p><div onclick="window.open(\'http://www.freietonne.de/index.php?site=43&infotyp=1\');openKosmos(\'menu/upload_GPS.php\');"><a href="#">Upload Meine GPS-Aufzeichnungen</a></div></p>';
   $EigeneProgramme=$EigeneProgramme.'<p><div onclick="openKosmos(\'menu/start_CMD.php\');">Admin-Shell</div></p>';
   $EigeneProgramme=$EigeneProgramme.'<p><a href=menu/stop_ft.html>Stop FreieTonne</a></p>';

}
//Wenn FreieTonne-Server selbst
if(is_file('../admin/_cfg.php')&&is_dir('../ft-usb-install')) {
   $freietonne='true';

   // Wir brauchen etwas Werbung ...
   if ((strpos($_SERVER['HTTP_REFERER'],'freietonne.de') === FALSE)&&(!isset($_GET['lat']))&&(strpos($_SERVER['HTTP_USER_AGENT'],'Android') == FALSE)){
      //header("Location: http://www.freietonne.de/");
      //exit;
   }
}

//Wenn MacOSX Client ohne DB
if(is_dir('/Applications/XAMPP')) {
   $macosx='true';
   $offline = 'true';
   if(!isset($_GET['lat'])) { $kursverlauf = 'window.setTimeout("toogleKursverlauf()",5000);toogleKursverlauf();'; }
}

// Wenn ftdl.de
if(is_dir('../tile-cache/tiles')){
   $linuxplanet='false';
   $linuxoffline='//';
   $LINUXJAVASCRIPTSTART='<!--';
   $LINUXJAVASCRIPTEND='-->';
   $maxzoom=18;
}
//Wenn Linux Client mit Planetfile, nicht Server
if(@is_file('/etc/mapnik-osm-data/osm.xml')||@is_file('/etc/mapnik-osm-carto-data/osm.xml')) {
   $linuxplanet='true';
   $linuxoffline='//';
   $LINUXJAVASCRIPTSTART='<!--';
   $LINUXJAVASCRIPTEND='-->';
   $maxzoom=18;
}

// Test Browsergeolocation unter Windows
//if(@is_file('/BrowserGeoLocation.LCK')){
//    $ipad = 'true';
//}

if((strpos($_SERVER['HTTP_USER_AGENT'],'AppleWebKit') !== FALSE AND
   strpos($_SERVER['HTTP_USER_AGENT'],'Mobile') !== FALSE) OR (
   strpos($_SERVER['HTTP_USER_AGENT'],'Android') !== FALSE)){

   // iPhone
   if(strpos($_SERVER['HTTP_USER_AGENT'],'iPhone') !== FALSE) {
      $iphone = 'true';
      $imeta = '
      <meta name="viewport" content="user-scalable=no, width=320">';
   }
   // iPad
   if(strpos($_SERVER['HTTP_USER_AGENT'],'iPad') !== FALSE) {
      $ipad = 'true';
      $imeta = '
      <meta name="viewport" content="user-scalable=no, width=device-width, initial-scale=1.0">';
      //$imeta='';
   }


   //"Mozilla/5.0 (Linux; U; Android 2.2; de-de; GT-P1000 Build/FROYO)
   // Android
   if(strpos($_SERVER['HTTP_USER_AGENT'],'Android') !== FALSE) {
      $android = 'true';
      $imeta = '
      <meta name="viewport" content="user-scalable=no, width=device-width, initial-scale=1.0">';
   }
}

if ($freietonne=='true'){
   $googleoffline='';
   $GOOGLEJAVASCRIPTSTART='';
   $GOOGLEJAVASCRIPTEND='';
   $maxzoom=18;
}else{
   // Google Werbung und GoogleMaps werden abgeschaltet
   $googleoffline='//';
   $GOOGLEJAVASCRIPTSTART='<!--';
   $GOOGLEJAVASCRIPTEND='-->';
   $maxzoom=18;
}


////////////////////////////////////////////////////////////////////////
// Eintragen im template html
//
//
$html = file_get_contents('template2.html');
$html = str_replace('###LON###',$lon,$html);
$html = str_replace('###LAT###',$lat,$html);
$html = str_replace('###ZOOM###',$zoom,$html);
$html = str_replace('###LAYERS###',$layers,$html);
$html = str_replace('###OFFLINE###',$offline,$html);
$html = str_replace('###VORSCHAUICON###',$vorschauicon,$html);
$html = str_replace('###KURSVERLAUF###',$kursverlauf,$html);
$html = str_replace('###FREIETONNE###',$freietonne,$html);
$html = str_replace('###WINDOWS###',$windows,$html);
$html = str_replace('###MACOSX###',$macosx,$html);
$html = str_replace('###LINUXPLANET###',$linuxplanet,$html);
$html = str_replace('###IPHONE###',$iphone,$html);
$html = str_replace('###IPAD###',$ipad,$html);
$html = str_replace('###ANDROID###',$android,$html);
$html = str_replace('###JOSM###',$is_josm,$html);
$html = str_replace('###IMETA###',$imeta,$html);
$html = str_replace('###GOOGLEOFFLINE###',$googleoffline,$html);
$html = str_replace('###GOOGLEJAVASCRIPTSTART###',$GOOGLEJAVASCRIPTSTART,$html);
$html = str_replace('###GOOGLEJAVASCRIPTEND###',$GOOGLEJAVASCRIPTEND,$html);
$html = str_replace('###LINUXOFFLINE###',$linuxoffline,$html);
$html = str_replace('###LINUXJAVASCRIPTSTART###',$LINUXJAVASCRIPTSTART,$html);
$html = str_replace('###LINUXJAVASCRIPTEND###',$LINUXJAVASCRIPTEND,$html);
$html = str_replace('###MAXZOOM###',$maxzoom,$html);
$html = str_replace('###EIGENEPROGRAMME###',$EigeneProgramme,$html);
$html = str_replace('###ONLINESTATUS###',$inetONLINE,$html);
$html = str_replace('###TILESERVERONLINE###',$tileserverONLINE,$html);
$html = str_replace('###TILESERVERIP###',$ip,$html);

//header("Pragma: no-cache");
//header("Cache-Control: no-store, no-cache, max-age=0, must-revalidate");
//header('Content-Type: text/html; charset=utf-8');
echo $html; exit;


?>
